
/* Chrysalide - Outil d'analyse de fichiers binaires
 * pglist.h - prototypes pour la gestion de l'ensemble des greffons
 *
 * Copyright (C) 2009-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _PLUGINS_PGLIST_H
#define _PLUGINS_PGLIST_H


#include <stdbool.h>
#include <gtk/gtk.h>


#include "plugin-def.h"
#include "plugin.h"



/* Procède au chargement des différents greffons trouvés. */
bool init_all_plugins(GObject *);

/* Procède au déchargement des différents greffons présents. */
void exit_all_plugins(void);

/* Founit less greffons offrant le service demandé. */
const GPluginModule **get_all_plugins_for_action(PluginAction, size_t *);


/**
 * Définitions des opérations appliquables à une catégories de greffons.
 */

#define process_all_plugins_for(a, f, ...)                  \
    {                                                       \
        size_t __count;                                     \
        const GPluginModule **__list;                       \
        size_t __i;                                         \
        __list = get_all_plugins_for_action(a, &__count);   \
        for (__i = 0; __i < __count; __i++)                 \
            f(__list[__i], a, __VA_ARGS__);                 \
    }                                                       \
    while (0)


/* DPS_FORMAT */

#define find_matching_format()

#define handle_binary_format(a, f, s)                                     \
    process_all_plugins_for(a, g_plugin_module_handle_binary_format, f, s)

#define preload_binary_format(a, f, i, s)                                 \
    process_all_plugins_for(a, g_plugin_module_preload_binary_format, f, i, s)

/* DPS_DISASSEMBLY */

#define process_disassembly_event(a, b) \
    process_all_plugins_for(a, g_plugin_module_process_disassembly_event, b)



#endif  /* _PLUGINS_PGLIST_H */
